/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	W a v e S u r f e r W r a p p e r
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {


		var moduleName = "WaveSurferWrapper"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
		
	
		function Module (idouter){  //}($p) {
			/// PRIVATE INSTANCE VARIABLES	
			//alert("waveSurferWrapper enter");
			var selectorOuter = "#"+idouter;
			var sPlayer = "myplayer";
			var selectorPlayer = "#myplayer";
			var $player = $(selectorPlayer);
			var player = document.getElementById(sPlayer);
			
			var wavesurfer;//=null;
			var wsready = false;
			var timerOn = true;
			var ntime=0;
			var dur=0;
			var surfpos; //decimal 0..1, ratio of playhead/duration
			var timerSyncTimer;
			
			//point to player
			if( mediaLocationType == MEDIA_LOCATION_LOCAL ){
				player = document.getElementById("cadetvideo");
				$player = $("#cadetvideo")
			} else if ( mediaLocationType == MEDIA_LOCATION_GENERIC_REMOTE ){
				player = document.getElementById("genericRemoteVideo");
				$player = $("#genericRemoteVideo")
			}


			//mediaTimerFunc();


			///PUBLIC METHODS
			this.buildup = buildup;
			this.loadMedia = loadMedia;
			this.teardown = teardown;
			
			
			function buildup(){
			
				if( wavesurfer ) return;
				
				//create the wavesurfer
				wavesurfer = WaveSurfer.create({
					container: selectorOuter + "> #waveform",
					waveColor: 'violet',
					progressColor: 'purple',
					scrollParent: 'true',
					normalize: 'false',
					forceDecode: 'true',
				plugins: [
					WaveSurfer.cursor.create({
						showTime: true,
						opacity: 1,
						color: 'white',
						formatTimeCallback: formatTime,
						customShowTimeStyle: {
							'background-color': '#000',
							color: '#fff',
							padding: '2px',
							'font-size': '12px'
						}
					})
				]
				});
				
				
				//when wavesurfer is ready attach...
				wavesurfer.on('ready', function () {
					wsready = true;
					
					// create the zoom slider controls and such...
					$("#waveform").before("<label for='zoomslider' id='zoomvalpara'>WaveForm  Zoom: (<span id='zoomvalshow'>20</span>)&nbsp;</label><input width='100px' id='zoomslider' class='zoomslider' tabindex='0' type='range' min='0' max='50' value='20' labeled-by='zoomvalpara'>");
					setTimeout(function(){
						//... and  delaying adding handlers until it's likely created already...
						//slider input to pause and zoom
						//$('#zoomslider')[0].oninput = function () {
						$('#zoomslider').on('input', function () {
							player.pause();
							$("#zoomvalshow").text(this.value);
							wavesurfer.zoom(Number(this.value));
						}
						);
						//zoom slider mouseup to allow waveform sync
						$("#zoomslider").on('mouseup', function(event) {
							//slider has been dropped somewhere, link player time to waveform time
							//console.log("mousedownFired");
							//code
							timerOn = true;
						});
					}, 100);
					
					
					//mousing in waveform area or zoom, pause and disconnect player time from waveform time
					$(selectorOuter).on('mousedown', function(event) {
						//console.log("mousedownFired");
						//code
						player.pause();
						timerOn = false;
					});
					//player is playing (has restarted) allow waveform sync
					$player.on('playing', function(event) {
						console.log("wavesurferwrappercadet: player playing");
						//code
						timerOn = true;
					});
					//if already disconnected, update player head and waveform sync again
					wavesurfer.on('seek', function (v) {
						if(timerOn) return;
						//console.log("seek: seekTime=["+wavesurfer.getCurrentTime()+"] dur=["+dur+"]")
						var val=v;
						player.currentTime = wavesurfer.getCurrentTime();//this.value;//
						//!!! WS PlayerDispatch.setCurrentTime();

						//timerOn = true;
					});
															
				});//wavesurfer.on ready
				
				timerSyncTimer = setInterval( syncWaveform, 30 );
				
			}// buildup
			
			
			function syncWaveform(){
				//synchronize waveform to player time
				if( !timerOn ) return;

				//alert(player.duration);
				//var ntime;
			/* !!!!! TIME FROM PLAYER	*/	
				ntime = player.currentTime;
				//document.getElementById("curtime").innerText = formatTime(ntime);//ntime.toFixed(3); //toString();

			/* !!!!! DURATION FROM PLAYER	*/	
				dur= player.duration;//283.52 
				//console.log("dur=["+dur+"]");
				//PlayerDispatch.playerGetDuration();   player.duration;
				
				//if( dur )					$("#mydur").text(formatTime(dur));//.toFixed(3));//document.getElementById("mydur").innerText = dur.toFixed(3);
	
				surfpos = ntime/dur;
				if( wsready ){
					wavesurfer.seekAndCenter(surfpos);//wavesurfer.seekAndCenter(surfpos); //wavesurfer.seekTo(surfpos);
				}
			}//syncWaveform
			
			function teardown(){
				if( wsready ){
					/**/
					//stop sync
					timerOn = false;
					clearInterval(timerSyncTimer);
					//wavesurfer.unAll();
					$player.off('playing');
					
					
					//$(selectorOuter).off('mousedown');
					//$("#zoomslider").off('mouseup');
					//$('#zoomslider')[0].oninput = null;
					
					//wavesurfer.off('ready');
					wavesurfer.empty();
					
					//var pluginmap = wavesurfer.getActivePlugins()
					//but what about cursor plugin, .destroy generates an error
					wavesurfer.destroy();
					//wavesurfer.cursor=null;
					wavesurfer = null;
				} else {
					//alert("wavesurfer not ready to tear down try later");
				}
				$("#zoomvalpara").remove();
				$("#zoomslider").remove();
			}//teardown
			
			function loadMedia(m){
				timerOn = false;
				wavesurfer.zoom(20);
				wavesurfer.load(m);
			}//load
			
			function formatTime(time){
				//return("foobar")
				//return [Math.floor(time % 3600 / 60), // minutes
					//('00' + Math.floor(time % 60)).slice(-2), // seconds
					//('000' + Math.floor(time % 1 * 1000)).slice(-3) // milliseconds
					//].join(':');
				return [('00' + Math.floor(time / 3600)).slice(-2), // hours
						('00' + Math.floor(time % 3600 / 60)).slice(-2), // minutes
						('00' + Math.floor(time % 60)).slice(-2)].join(':') + '.' + // seconds
						('000' + Math.floor(time % 1 * 1000)).slice(-2); // milliseconds				
			}

			this.buildup();
			
			return( this );

		} // WaveSurferWrapper Module constructor

}) (); //WaveSurferWrapper

